/*
 * BlinkenApplet
 * *************
 * 
 * Main Author: Manuel Flther
 * License: GNU General Public License
 * File: Starting Applet Class: BlinkScreen.java
 * Version: 0.1
 * Co-Author: -
 * Creation TimeDate: 2004_06_19 - 22:36
 * Last Edit TimeDate: 2004_06_22 - 16:41
 * 
 */

package BLToolkit;

import java.awt.*;

public class BlinkenScreen extends Canvas{
	

private Image offscreenImage;
private Graphics offscreenGraphics;
private Color lampColor;
private Color bgColor;
private int sizeX;
private int sizeY;
private BlinkenFrame screenFrame;


public BlinkenScreen(int sizeX, 
				   int sizeY, 
				   int colorDepth, 
				   Color lampColor, 
				   Color bgColor){
	this.lampColor = lampColor;
	this.bgColor = bgColor;
	this.sizeX = sizeX;
	this.sizeY = sizeY;

	screenFrame = new BlinkenFrame(18,8);

}

private void doDrawing()
{
	drawFrame(screenFrame);
}

private void drawFrame(BlinkenFrame bf){
	
	for(int x = 0;x<bf.GetSizeX();x++)
		for(int y = 0;y<bf.GetSizeY();y++)
				Lamp(x+(x*10),y+(y*10),8,8,true,4);
}

private void Lamp(int posX, 
				  int posY, 
				  int sizeX, 
				  int sizeY, 
				  boolean visible, int scale){
	if(visible==true)
	{
		switch(scale)
		{
			
			case 5:
				offscreenGraphics.setColor(new Color(250,100,100));
			break;
			case 4:
				offscreenGraphics.setColor(new Color(225,100,100));
			break;
			case 3:
				offscreenGraphics.setColor(new Color(200,100,100));
			break;
			case 2:
				offscreenGraphics.setColor(new Color(175,100,100));
			break;
			case 1:
				offscreenGraphics.setColor(new Color(150,90,90));
			break;
			case 0:
				offscreenGraphics.setColor(new Color(125,100,100));
			break;
			default:
				offscreenGraphics.setColor(Color.red);
			break;
			
		}
		offscreenGraphics.fillArc(posX, posY, sizeX, sizeY, 0, 360);
	}

}

public void update(Graphics g)
{
	paint(g);
}

public void paint(Graphics g)
{
	//for double buffering 
	offscreenImage = createImage(getSize().width, getSize().height);
	offscreenGraphics = offscreenImage.getGraphics();
	doDrawing();
	if(offscreenImage != null)
		g.drawImage(offscreenImage, 0, 0, this);
}


}

